.\"	$NetBSD: chmod.2,v 1.33.6.1 2009/01/04 17:02:20 christos Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)chmod.2	8.1 (Berkeley) 6/4/93
.\"
.Dd January 4, 2009
.Dt CHMOD 2
.Os
.Sh NAME
.Nm chmod ,
.Nm lchmod ,
.Nm fchmod
.Nd change mode of file
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/stat.h
.Ft int
.Fn chmod "const char *path" "mode_t mode"
.Ft int
.Fn lchmod "const char *path" "mode_t mode"
.Ft int
.Fn fchmod "int fd" "mode_t mode"
.Sh DESCRIPTION
The function
.Fn chmod
sets the file permission bits
of the file
specified by the pathname
.Fa path
to
.Fa mode .
.Fn fchmod
sets the permission bits of the specified
file descriptor
.Fa fd .
.Fn lchmod
is like
.Fn chmod
except in the case where the named file is a symbolic link,
in which case
.Fn lchmod
sets the permission bits of the link,
while
.Fn chmod
sets the bits of the file the link references.
.Fn chmod
verifies that the process owner (user) either owns
the file specified by
.Fa path
(or
.Fa fd ) ,
or
is the super-user.
A mode is created from
.Em or'd
permission bit masks
defined in
.Aq Pa sys/stat.h :
.Bd -literal -offset indent -compact
#define S_IRWXU 0000700    /* RWX mask for owner */
#define S_IRUSR 0000400    /* R for owner */
#define S_IWUSR 0000200    /* W for owner */
#define S_IXUSR 0000100    /* X for owner */

#define S_IRWXG 0000070    /* RWX mask for group */
#define S_IRGRP 0000040    /* R for group */
#define S_IWGRP 0000020    /* W for group */
#define S_IXGRP 0000010    /* X for group */

#define S_IRWXO 0000007    /* RWX mask for other */
#define S_IROTH 0000004    /* R for other */
#define S_IWOTH 0000002    /* W for other */
#define S_IXOTH 0000001    /* X for other */

#define S_ISUID 0004000    /* set user id on execution */
#define S_ISGID 0002000    /* set group id on execution */
#define S_ISVTX 0001000    /* save swapped text even after use */
.Ed
.Pp
If mode
.Dv ISVTX
(the
.Sq sticky bit )
is set on a regular file, it historically meant that the system should
save a shareable copy of the program text in the swap area.
When applied to commonly used programs like the shell or editor, this
would decrease memory usage and startup time.
In
.Nx ,
the sticky bit may still be set on regular files by the super-user,
but has no effect.
The historical meaning became obsolete in the 1980s with the advent of
memory-mapped executables, and is only documented as a matter of
historical interest.
.Pp
If mode
.Dv ISVTX
(the
.Sq sticky bit )
is set on a directory,
an unprivileged user may not delete or rename
files of other users in that directory.
The sticky bit may be set by any user on a directory which the user
owns or has appropriate permissions.
.Pp
For more information about the properties of the sticky bit, see
.Xr sticky 7 .
.Pp
Changing the owner of a file
turns off the set-user-id and set-group-id bits;
writing to a file
turns off the set-user-id and set-group-id bits
unless the user is the super-user.
This makes the system somewhat more secure
by protecting set-user-id (set-group-id) files
from remaining set-user-id (set-group-id) if they are modified,
at the expense of a degree of compatibility.
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.
Otherwise, a value of \-1 is returned and
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn chmod
and
.Fn lchmod
will fail and the file mode will be unchanged if:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of the path prefix is not a directory.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded
.Dv {NAME_MAX}
characters, or an entire path name exceeded
.Dv {PATH_MAX}
characters.
.It Bq Er ENOENT
The named file does not exist.
.It Bq Er EACCES
Search permission is denied for a component of the path prefix.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating the pathname.
.It Bq Er EPERM
The effective user ID does not match the owner of the file and
the effective user ID is not the super-user.
.It Bq Er EPERM
The mode includes the setgid bit
.Pq Dv S_ISGID
but the file's group is neither the effective group ID nor is it in the
group access list.
.It Bq Er EROFS
The named file resides on a read-only file system.
.It Bq Er EFAULT
.Fa path
points outside the process's allocated address space.
.It Bq Er EIO
An I/O error occurred while reading from or writing to the file system.
.It Bq Er EFTYPE
The effective user ID is not the super-user, the
.Fa mode
includes the sticky bit
.Pq Dv S_ISVTX ,
and
.Fa path
does not refer to a directory.
.El
.Pp
.Fn fchmod
will fail if:
.Bl -tag -width Er
.It Bq Er EBADF
The descriptor is not valid.
.It Bq Er EINVAL
.Fa fd
refers to a socket, not to a file.
.It Bq Er EPERM
The effective user ID does not match the owner of the file and
the effective user ID is not the super-user.
.It Bq Er EPERM
The mode includes the setgid bit
.Pq Dv S_ISGID
but the file's group is neither the effective group ID nor is it in the
group access list.
.It Bq Er EROFS
The file resides on a read-only file system.
.It Bq Er EIO
An I/O error occurred while reading from or writing to the file system.
.It Bq Er EFTYPE
The effective user ID is not the super-user, the
.Fa mode
includes the sticky bit
.Pq Dv S_ISVTX ,
and
.Fa fd
does not refer to a directory.
.El
.Sh SEE ALSO
.Xr chmod 1 ,
.Xr chflags 2 ,
.Xr chown 2 ,
.Xr open 2 ,
.Xr stat 2 ,
.Xr getmode 3 ,
.Xr setmode 3 ,
.Xr sticky 7 ,
.Xr symlink 7
.Sh STANDARDS
The
.Fn chmod
function conforms to
.St -p1003.1-90 .
.Sh HISTORY
The
.Fn fchmod
function call
appeared in
.Bx 4.2 .
The
.Fn lchmod
function call appeared in
.Nx 1.3 .
